ghc-7.6.3: The GHC API

Safe Haskell | None

FunDeps

# Documentation

data FDEq

Constructors

FDEq |
Fields fd_pos :: Int fd_ty_left :: Type fd_ty_right :: Type

Instances

Outputable FDEq |

data Equation

Constructors

FDEqn |
Fields fd_qtvs :: [TyVar] fd_eqs :: [FDEq] fd_pred1 :: Pred_Loc fd_pred2 :: Pred_Loc

pprEquation :: Equation -> SDoc

oclose :: [PredType] -> TyVarSet -> TyVarSet

improveFromInstEnv :: (InstEnv, InstEnv) -> Pred_Loc -> [Equation]

improveFromAnother :: Pred_Loc -> Pred_Loc -> [Equation]

checkInstCoverage :: Class -> [Type] -> Bool

checkFunDeps :: (InstEnv, InstEnv) -> ClsInst -> Maybe [ClsInst]

pprFundeps :: Outputable a => [FunDep a] -> SDoc